#include "TinyMqtt.h"    
#include "TinyStreaming.h"
#include "Adafruit_VL53L0X.h"
// #include <Wire.h>
// #include "M5StickCPlus.h"
#include <WiFi.h>


/* 
 * Programme qui affiche la distance trouvée par le capteur ToF 
 * et l'envoie à un autre M5 par MQTT
*/

#define ROUE_GAUCHE 0 // 1 : Oui, 0 : Non

#define DIST_MAX 200
#define DIST_MIN 50
#define NUM_MAX 250
#define NUM_MIN 145

#define S_REPOS 193


// Configure the name and password of the connected wifi and your MQTT Serve
// host. 
#define SSID           "froll_n_roll"
#define PASSWORD      "test_froll"
#define BROKER        "192.168.4.1"
#define BROKER_PORT   1883

static MqttClient client;

unsigned long lastMsg = 0;
#define MSG_BUFFER_SIZE (50)
char msg[MSG_BUFFER_SIZE];





Adafruit_VL53L0X lox = Adafruit_VL53L0X();

void setup() {
  // Décommenter si les pins SDA et SCL ne sont pas branchés aux bons pîns
  // Wire.begin(0, 26, 400000UL);  // join i2c bus (address optional for master)
  // M5.begin();
  Serial.begin(115200);

  // Connexion au capteur ToF
  if (!lox.begin()) {
    while(!lox.begin()){
      delay(10);
    }
  }

  // Connexion wifi
  WiFi.mode(WIFI_STA);
  WiFi.begin(SSID, PASSWORD);

  while (WiFi.status() != WL_CONNECTED)
	{ 
    delay(100); 
  }
  Serial.println("Wifi connecté");
  // Serial << "Connected to " << ssid << "IP address: " << WiFi.localIP() << endl;
  // Connexion au broker
  while (not client.connected())
  {
    client.connect(BROKER, BROKER_PORT);
    delay(100);
  }
  Serial.println("Broker connecté");

}




uint16_t conver_dist(uint16_t distance);

void loop() {
  // Perte connexion
  if(WiFi.status() != WL_CONNECTED)
	{ 
    WiFi.begin(SSID, PASSWORD);
    while (WiFi.status() != WL_CONNECTED);
  }

  if(not client.connected())
  {
    client.connect(BROKER, BROKER_PORT);
    while(not client.connected());
  }


  client.loop();
  
  VL53L0X_RangingMeasurementData_t measure;
  
  lox.rangingTest(&measure, false); // pass in 'true' to get debug data printout!

  if (measure.RangeStatus == 0) {  // phase failures have incorrect data
    snprintf(msg, MSG_BUFFER_SIZE, "%d", conver_dist(measure.RangeMilliMeter));
  }
  client.publish("roue_master", msg);
  delay(100);
}




uint16_t conver_dist(uint16_t distance){
  if(distance > DIST_MAX){
    distance = DIST_MAX;
  }
  else if(distance < DIST_MIN){
    distance = DIST_MIN;
  }
  Serial.println(distance);
  int tmp = ((distance - DIST_MIN)*(NUM_MAX-NUM_MIN)+NUM_MIN*(DIST_MAX-DIST_MIN))/(DIST_MAX-DIST_MIN);
  if(ROUE_GAUCHE){
    return 2*S_REPOS - tmp;
  }
  return tmp;
}